/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

 /*
 * CarsFrame.java
 *
 * Created on May 3, 2010, 9:19:22 AM
 */
package cz.muni.fi.pv168.swingdemo;

import java.awt.Color;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.ExecutionException;
import javax.swing.SwingWorker;

/**
 *
 * @author tomp
 */
public class CarsFrame extends javax.swing.JFrame {

    /**
     * Creates new form MainFrame
     */
    public CarsFrame() {
        initComponents();
        CarsTableModel model = (CarsTableModel) jTableCars.getModel();
        model.addCar(new Car(1, "Renault Clio", "2B6 7895", Color.RED, Fuel.GAS));
        model.addCar(new Car(2, "Škoda 120", "2A1 9999", Color.PINK, Fuel.LPG));
    }
    private Random random = new Random();
    private static final String[] CAR_TYPES = {"Škoda Felicia", "Škoda Octavia",
        "Ford Focus", "Ford Fiesta", "Renault Clio", "Porsche Carrera"};
    private static final Color[] CAR_COLORS = {Color.BLACK, Color.BLUE,
        Color.RED, Color.GREEN, Color.PINK, Color.WHITE, Color.YELLOW};

    private Car randomCar() {
        return new Car(
                random.nextInt(10000),
                CAR_TYPES[random.nextInt(CAR_TYPES.length)],
                "2C1 " + (random.nextInt(9000) + 1000),
                CAR_COLORS[random.nextInt(CAR_COLORS.length)],
                Fuel.values()[random.nextInt(Fuel.values().length)]);
    }

    private PropertyChangeListener progressListener = new PropertyChangeListener() {
        public void propertyChange(PropertyChangeEvent evt) {
            if (evt.getPropertyName().equals("progress")) {
                jLabelCarGenerationStatus.setText("Generation in progress... " + evt.getNewValue());
            }
        }
    };

    private GenerateCarsSwingWorker generateCarsSwingWorker;

    private class GenerateCarsSwingWorker extends SwingWorker<Integer, Car> {

        List<Car> generated = new ArrayList<Car>();

        @Override
        protected Integer doInBackground() throws Exception {
            for (int i = 0; i < 10; i++) {
                // add new car up to 10
                if (isCancelled()) {
                    return null;
                }
                Car car = randomCar();
                generated.add(car);
                publish(car);
                setProgress(i);
                // simulujeme časově náročnou operaci
                Thread.sleep(200);
            }
            return generated.size();
        }

        @Override
        protected void process(List<Car> chunks) {
            for (Car car : chunks) {
                ((CarsTableModel) jTableCars.getModel()).addCar(car);
            }
        }

        @Override
        protected void done() {
            jButtonGenerateCars.setEnabled(true);
            jButtonCancel.setEnabled(false);
            generateCarsSwingWorker = null;
            if (isCancelled()) {
                jLabelCarGenerationStatus.setText("Generation cancelled");
            } else {
                try {
                    jLabelCarGenerationStatus.setText("All cars generated: " + get() + "\n");
                } catch (ExecutionException ex) {
                    jLabelCarGenerationStatus.setText("Exception thrown in doInBackground(): " + ex.getCause() + "\n");
                } catch (InterruptedException ex) {
                    // K tomuto by v tomto případě nemělo nikdy dojít (viz níže)
                    throw new RuntimeException("Operation interrupted (this should never happen)", ex);
                }
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTableCars = new javax.swing.JTable();
        jButtonAddCar = new javax.swing.JButton();
        jButtonGenerateCars = new javax.swing.JButton();
        jLabelCarGenerationStatus = new javax.swing.JLabel();
        jButtonCancel = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenu2 = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("cz/muni/fi/pv168/swingdemo/SwingDemoBundle"); // NOI18N
        setTitle(bundle.getString("main.title")); // NOI18N

        jTableCars.setModel(new CarsTableModel());
        jScrollPane1.setViewportView(jTableCars);

        jButtonAddCar.setText("Add car");
        jButtonAddCar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddCarActionPerformed(evt);
            }
        });

        jButtonGenerateCars.setText("Generate cars");
        jButtonGenerateCars.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonGenerateCarsActionPerformed(evt);
            }
        });

        jLabelCarGenerationStatus.setText("No cars generated yet");

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        jMenu1.setText("File");
        jMenuBar1.add(jMenu1);

        jMenu2.setText("Edit");
        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButtonAddCar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonGenerateCars)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelCarGenerationStatus)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jButtonCancel)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 227, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonAddCar)
                    .addComponent(jButtonGenerateCars)
                    .addComponent(jLabelCarGenerationStatus)
                    .addComponent(jButtonCancel))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonAddCarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddCarActionPerformed
        CarsTableModel model = (CarsTableModel) jTableCars.getModel();
        model.addCar(randomCar());        // TODO add your handling code here:
    }//GEN-LAST:event_jButtonAddCarActionPerformed

    private void jButtonGenerateCarsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonGenerateCarsActionPerformed
        if (generateCarsSwingWorker != null) {
            throw new IllegalStateException("Operation already in progress.");
        }
        jButtonGenerateCars.setEnabled(false);
        jButtonCancel.setEnabled(true);
        generateCarsSwingWorker = new GenerateCarsSwingWorker();
        generateCarsSwingWorker.addPropertyChangeListener(progressListener);
        generateCarsSwingWorker.execute();
    }//GEN-LAST:event_jButtonGenerateCarsActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        if (generateCarsSwingWorker == null) {
            throw new IllegalStateException("Operation is not running.");
        }
        generateCarsSwingWorker.cancel(true);
    }//GEN-LAST:event_jButtonCancelActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new CarsFrame().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAddCar;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonGenerateCars;
    private javax.swing.JLabel jLabelCarGenerationStatus;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableCars;
    // End of variables declaration//GEN-END:variables

}
