/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv168.swingdemo;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author tomp
 */
public class CarsTableModel extends AbstractTableModel {

    private List<Car> cars = new ArrayList<Car>();

    @Override
    public int getRowCount() {
        return cars.size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Car car = cars.get(rowIndex);
        switch (columnIndex) {
            case 0:
                return car.getId();
            case 1:
                return car.getRegistrationNumber();
            case 2:
                return car.getType();
            case 3:
                return car.getColor();
            case 4:
                return car.getFuel();
            default:
                throw new IllegalArgumentException("columnIndex");
        }
    }

    public void addCar(Car car) {
        cars.add(car);
        int lastRow = cars.size() - 1;
        fireTableRowsInserted(lastRow, lastRow);
    }

    @Override
    public String getColumnName(int columnIndex) {
        switch (columnIndex) {
            case 0:
                return "Id";
            case 1:
                return "RegistrationNumber";
            case 2:
                return "Type";
            case 3:
                return "Color";
            case 4:
                return "Fuel";
            default:
                throw new IllegalArgumentException("columnIndex");
        }
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        switch (columnIndex) {
            case 0:
                return Integer.class;
            case 1:
            case 2:
                return String.class;
            case 3:
                return Color.class;
            case 4:
                return Fuel.class;
            default:
                throw new IllegalArgumentException("columnIndex");
        }
    }
}
